/*
Example for Led_Driver Click

    Date          : Jul 2017.
    Author        : Djordje Rosic

Test configuration STM32 :
    
    MCU             : STM32F107VCT6
    Dev. Board      : EasyMx PRO v7 for STM32 ARM
    SW              : mikroC PRO for ARM v5.1.0

Description :
  Place MCP1664 click in mikroBus socket 1
  This example shows basic control of light brightness with PWM,
  duty cycle is controled with potentiometer P1, jumper J4 needs to be set on A3
 
*/

unsigned int currentDuty;


void systemInit()
{
    GPIO_Digital_Input (&GPIOA_BASE, _GPIO_PINMASK_3 );
    GPIO_Digital_Output(&GPIOA_BASE,_GPIO_PINMASK_0);
    
    ADC_Set_Input_Channel(_ADC_CHANNEL_3);                                // Choose ADC channel
    ADC1_Init();                                                          // ADC Init
    
    Delay_ms(100);
    PWM_TIM2_Init(10000);
    PWM_TIM2_Set_Duty(currentDuty,  _PWM_NON_INVERTED, _PWM_CHANNEL1);   // Set current duty for PWM_TIM2
    PWM_TIM2_Start(_PWM_CHANNEL1, &_GPIO_MODULE_TIM2_CH1_PA0);
}

void main()
{

    systemInit();

    while(1)
    {
        currentDuty = ADC1_Get_Sample(3);
        Delay_ms(1);
        PWM_TIM2_Set_Duty(currentDuty,  _PWM_NON_INVERTED, _PWM_CHANNEL1);
    }
}